package cn.estsh.i3plus.pojo.base.enumutil;

import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * @Description : 模块枚举类
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-12-25 21:08
 * @Modify:
 **/
public class BlockReportEnumUtil {


    /**
     * 报表元素枚举
     * WORDS(1,"文字"),PIC(2,"图片"),REPORT(3,"报表");
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum REPORT_ELEMENT_TYPE{

        WORDS(1,"文字"),PIC(2,"图片");

        private int value;
        private String description;

        REPORT_ELEMENT_TYPE() {
        }

        REPORT_ELEMENT_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

    }


    /**
     * 报表布局枚举
     * TABLE(1,"表格"),CHART(2,"图表");
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum REPORT_LAYOUT_TYPE{

        TABLE(1,"表格"),CHART(2,"图表");

        private int value;
        private String description;

        REPORT_LAYOUT_TYPE() {
        }

        REPORT_LAYOUT_TYPE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }



    /**
     * 功能级别
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum METHOD_LEVEL {
//        PLUGIN(1, "插件"),
        MODULE(2, "顶级目录"),
        METHOD(3, "二级目录");
//        BUTTON(4, "按钮");

        private int value;
        private String description;

        private METHOD_LEVEL(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 数据状态
     *  1 启用
     *  2 禁用
     *  3 锁定
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum DATA_STATUS {
        ENABLE(1, "启用", "fa fa-success cell-fa fa-check"),
        DISABLE(2, "禁用", "fa fa-disabled cell-fa fa-times-circle");

        private int value;
        private String name;
        private String description;

        DATA_STATUS() {
        }

        DATA_STATUS(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getName() {
            return name;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].getName();
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * HQL WHERE 条件
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum HQL_WHERE{

        GT(1, ">", "大于"),
        GT_EQUAL(2, ">=", "大于等于"),
        LT(3, "<", "小于等于"),
        LT_EQUAL(4, "<=", "小于等于"),
        LIKE(5, "like", "模糊"),
        LIKE_LEFT(6, "like", "左模糊"),
        LIKE_RIGHT(7, "like", "右模糊"),
        EQUAL(8, "=", "等于"),
        EQUAL_NOT(9, "!=", "不等于"),
        AND(10, "and", "AND"),
        OR(11, "or", "OR"),
        NOT(12, "not", "NOT"),
        IS_NULL(13, "is null", "IS NULL"),
        IS_NOT_NULL(14, "is not null", "IS NOT NULL");

        private int value;
        private String name;
        private String description;

        HQL_WHERE() {
        }

        HQL_WHERE(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getName() {
            return name;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].getName();
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /***
     * 数据量表连接方式
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum HQL_REF{
        LEFT_JOIN(1, "left join", "左连接"),
        RIGHT_JOIN(2, "right join", "右连接"),
        INNER_JOIN(3, "inner join", "内连接");

        private int value;
        private String name;
        private String description;

        HQL_REF() {
        }

        HQL_REF(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getName() {
            return name;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].getName();
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum HQL_AGGREGATION{

        AVG(1, "avg", "平均值"),
        MIN(2, "min", "最小值"),
        MAX(3, "max", "最大值"),
        SUM(4, "sum", "总和"),
        COUNT(5, "count", "计数");

        private int value;
        private String name;
        private String description;

        HQL_AGGREGATION() {
        }

        HQL_AGGREGATION(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getName() {
            return name;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].getName();
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

}
