package cn.estsh.i3plus.pojo.report.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description :
 * @Reference :
 * @Author : Adair Peng
 * @CreateDate : 2019-01-18 11:32
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="BR_POJO_ATTR")
@Api(value="报表模板",description = "报表模板")
public class BrPojoAttr extends BaseBean {

    @Column(name="TEMPLATE_ID")
    @ApiParam(value ="模板编号" ,example = "-1")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long templateId;

    @Column(name="SERVER_ID")
    @ApiParam(value ="服务编号",example = "-1")
    private Integer serverId;

    @Column(name="POJO_CLASS_PATH")
    @ApiParam(value ="对象ClassPath")
    private String pojoClassPath;

    @Column(name="POJO_NAME")
    @ApiParam(value ="对象名称")
    private String pojoName;

    @Column(name="POJO_NAME_ALIAS")
    @ApiParam(value ="对象别名")
    private String pojoNameAlias;

    @Column(name="ATTR_TYPE")
    @ApiParam(value ="属性类型",example = "-1")
    private Integer attrType;

    @Column(name="ATTR_REF_TYPE")
    @ApiParam(value ="关系类型",example = "-1")
    private Integer attrRefType;

    @Column(name="DATA_TYPE")
    @ApiParam(value ="数据类型",example = "-1")
    private Integer dataType;

    @Column(name="AGGREGATION_TYPE")
    @ApiParam(value ="聚合类型",example = "-1")
    private Integer aggregationType;

    @Column(name="ATTR_SORT")
    @ApiParam(value ="字段排序")
    private Integer attrSort;

    @Column(name="ATTR_DEFAULT_VALUE")
    @ApiParam(value ="属性默认值")
    private String attrDefaultValue;

    @Column(name="ATTR_SHOW")
    @ApiParam(value ="属性是否显示",example = "-1")
    private Integer attrShow;

}
