package cn.estsh.i3plus.pojo.report.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description :
 * @Reference :
 * @Author : Adair Peng
 * @CreateDate : 2019-01-18 11:31
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="BR_REF_SERVER_POJO")
@Api(value="报表模板",description = "报表模板")
public class BrRefServerPojo extends BaseBean {

    @Column(name="TEMPLATE_ID")
    @ApiParam(value ="模板编号" ,example = "-1")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long templateId;

    @Column(name="TEMPLATE_NAME_RDD")
    @ApiParam(value ="模板名称" , access ="模板名称")
    private String templateNameRdd;

    @Column(name="SERVER_ID")
    @ApiParam(value ="服务编号" ,example = "-1")
    private Integer serverId;

    @Column(name="SERVER_NAME_RDD")
    @ApiParam(value ="服务名称" , access ="模板名称")
    private String serverNameRdd;

    @Column(name="SERVER_POJO_NAME_RDD")
    @ApiParam(value ="服务对象名称" , access ="模板名称")
    private String serverPojoNameRdd;

    @Column(name="SERVER_POJO_NAME_ALIAS")
    @ApiParam(value ="服务对象别名" , access ="模板名称")
    private String serverPojoNameAlias;

    @Column(name="SERVER_POJO_CLASS_PATH")
    @ApiParam(value ="服务对象名称" , access ="模板名称")
    private String serverPojoClassPath;

}
