package cn.estsh.i3plus.pojo.report.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description :
 * @Reference :
 * @Author : Adair Peng
 * @CreateDate : 2019-01-18 11:23
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="BR_CUSTOM_HQL")
@Api(value="报表模板",description = "报表模板")
public class BrTemplate extends BaseBean {

    @Column(name="NAME")
    @ApiParam(value ="模板名称" , access ="模板名称")
    private String name;

    @Column(name="TEMPLATE_TYPE")
    @ApiParam(value ="模板类型" , example ="-1",access="表格，图表")
    private Integer templateType;

    @Column(name="TEMPLATE_STATUS")
    @ApiParam(value ="模板状态" , example ="-1",access="模板状态")
    private Integer templateStatus;

    @Column(name="NUM_POJO")
    @ApiParam(value ="对象数量" , example ="0" , access ="权限模块数量")
    private Integer numPojo;

    @Column(name="TEMPLATE_POJO_NAMES_RDD",columnDefinition = "TEXT")
    @ApiParam(value ="对象名称" , access ="对象名称")
    private String templatePojoNamesRdd;

    @Column(name="NUM_SERVER")
    @ApiParam(value ="对象数量" , example ="0" , access ="权限模块数量")
    private Integer numServer;

    @Column(name="TEMPLATE_SERVER_NAMES_RDD",columnDefinition = "TEXT")
    @ApiParam(value ="服务名称" , access ="服务名称")
    private String templateServerNamesRdd;

    @Column(name="NUM_TEMPLATE_ATTR_FILTER")
    @ApiParam(value ="对象数量" , example ="0" , access ="权限模块数量")
    private Integer numTemplateAttrFilter;

    @Column(name="template_attr_filter_list",columnDefinition = "TEXT")
    @ApiParam(value ="模板查询条件" , access ="模板查询条件")
    private String templateAttrFilterList;

    @Column(name="NUM_TEMPLATE_ATTR_FILTER_GROUP")
    @ApiParam(value ="对象数量" , example ="0" , access ="权限模块数量")
    private Integer numTemplateAttrFilterGroup;

    @Column(name="TEMPLATE_ATTR_FILTER_GROUP_LIST",columnDefinition = "TEXT")
    @ApiParam(value ="模板分组条件" , access ="模板分組条件")
    private String templateAttrFilterGroupList;

    @Column(name="NUM_TEMPLATE_ATTR_SHOW")
    @ApiParam(value ="对象数量" , example ="0" , access ="权限模块数量")
    private Integer numTemplateAttrShow;

    @Column(name="TEMPLATE_ATTR_SHOW_LIST",columnDefinition = "TEXT")
    @ApiParam(value ="模板显示属性" , access ="模板显示属性")
    private String templateAttrShowList;

    @Column(name="TEMPLATE_DESCRIPTION")
    @ApiParam(value ="模板描述" , access ="模板描述")
    private String templateDescription;

    @Column(name="TEMPLATE_HTML",columnDefinition = "TEXT")
    @ApiParam(value ="模板HTML" , access ="模板HTML")
    private String templateHtml;

}
